## install.packages("deal")
## install.packages("Ecdat")

##@@@f[^̓ǂݍ

library(Ecdat)

data(Fair)
head(Fair)

data = Fair[,c(-2,-3,-9,-7)]
data[] = lapply(data,as.factor)

temp=data[,5]
data[,5] = data[,1]
data[,1] = temp


colnames(data) = c("K","q","@","","")
head(data)
data = data[,c("K","","@","q","")]


### A  deal̓ǂݍ݂Ǝs@Bayesian Network 

library(deal)
network.prior<- network(data)
prior.distribution <- jointprior(network.prior)
update <- learn(network.prior, data, prior.distribution)
network.post <- autosearch(getnetwork(update), data,prior.distribution,trace=FALSE)
plot(getnetwork(network.post),main="Bayesian Network",showban=TRUE)

###@B@BanList

ban <- rbind(cbind(1,1:5),cbind(1:5,4),cbind(1:5,5))
banlist(network.prior) = ban
update <- learn(network.prior, data, prior.distribution)
network.post <- autosearch(getnetwork(update), data,prior.distribution,trace=FALSE)
plot(getnetwork(network.post),main="Bayesian Network",showban=FALSE)


## @C@t

prob = localprob(getnetwork(network.post))


### P(K=5) 


Pro = function(localprob=prob,A=1:2,B=1:2,C=1:5,D=1:7,E=5){
  PR=0
  for(e in E){
    for(a in A) { 					 		## a = sex
      if(a == 1){sex = "male"} else{sex = "female"}
      
      for(b in B) {
        if(b ==1){kid = "yes"}else{kid="no"}	## b = kid
        for(c in C) {   				## c = syukyo
          rel = as.character(c)
          for(d in D){				## d = education
            if(d==1){edu="9"}
            if(d==2){edu="12"}
            if(d==3){edu="14"}
            if(d==4){edu="16"}
            if(d==5){edu="17"}
            if(d==6){edu="18"}
            if(d==7){edu="20"}
            Temp = 
              prob$K[e,edu,kid,sex] *
              prob$[edu,rel,kid,sex] *
              prob$@[rel,kid,sex] *
              prob$q[kid] *
              prob$[sex] 
            PR = PR + as.vector(Temp)
            
          }
        }
      }
      
    }
  }
  return(PR)
}

Pr = Pro()				###	P(K=5)
P_MAN = Pro(A=1)			###	P(K=5 |@ = j) *P( = j)
P_Woman = Pro(A=2)		###	P(K=5 |@ = ) *P( = j

P_M = P_MAN / Pr			###	P( = j | K = 5)
P_W = P_Woman / Pr		###	P( =  | K = 5)

P_Kid = Pro(B=1)			###	P(K = 5 | q = yes ) * P(q = yes)
P_NoKid = Pro(B=2)		###	P(K = 5 | q = no )	 * P(q = no)

P_K = P_Kid / Pr			###	P(q = yes | K = 5)	
P_NK = P_NoKid / Pr		###	P(q	= no  | K = 5)

Pr = Pro()				    ###	P(K=5)
P_MAN = Pro(A=1)			###	P(K=5 |@ = j) *P( = j)
P_Woman = Pro(A=2)		###	P(K=5 |@ = ) *P( = j

P_M = P_MAN / Pr			###	P( = j | K = 5)
P_W = P_Woman / Pr		###	P( =  | K = 5)

P_Kid = Pro(B=1)			###	P(K = 5 | q = yes ) * P(q = yes)
P_NoKid = Pro(B=2)		###	P(K = 5 | q = no )	 * P(q = no)

P_K = P_Kid / Pr			###	P(q = yes | K = 5)	
P_NK = P_NoKid / Pr		###	P(q	= no  | K = 5)

P_E9 = Pro(D=1)
P_E9_14 = Pro(D = 1:3) /Pr
P_E17_20 = Pro(D = 4:7) /Pr


cat(paste("P(K=5) = ",round(Pr,digits=3),"\n",
          "P( = j | K = 5) = ", round(P_M,digits = 3),"\n",
          "P( =  | K = 5) = ", round(P_W,digits = 3),"\n",
          "P(q = yes | K = 5) = ", round(P_K,digits = 3),"\n",    
          "P(q = no | K = 5) = ", round(P_NK,digits = 3),"\n",
          "P( = 9~14 | K = 5) = ", round(P_E9_14,digits = 3),"\n",
          "P( = 16~20 | K = 5) = ", round(P_E17_20,digits = 3),"\n",
          sep="") )
