#@ẽpbP[W̃CXg[
# install.packages("lda")
# install.packages("wordcloud")
# install.packages("tm")
# install.packages("RColorBrewer")
# install.packages("slam")
# install.packages ("RMeCab", repos = "http://rmecab.jp/R")

#Af[^̓ǂݍ
## 1. Data input
iphonedata <- read.csv("iphone7.csv",stringsAsFactors = F)
galaxydata <- read.csv("galaxy s7.csv",stringsAsFactors = F)
icomment <- iphonedata[,1]
gcomment <- galaxydata[,1]

#BMeCabɂ`ԑf
## 2. Pre-processing 
library(RMeCab)
Voc = function(x){
  word = list()
  l = length(x)
  count = 1
  lda.doc = list(length(l))
  for(i in l:1){
    if(x[i]!=""){
      word[[i]] = RMeCabC(x[i])
      temp = unlist(word[[i]])
      temp = gsub("\\(","",temp)
      temp = gsub("\\)","",temp)
      temp = gsub("\\+","",temp)
      temp = temp[which(names(temp) %in% c("","`e"))]@@ ##@̗ŕ͂Ɏĝ͖ƌ`e
      if(length(temp)!=0)  {  
        if( temp[1]!= ""){
          temp2 = paste(temp,collapse =" ")
          lda.doc[[count]] = temp2
          count = count + 1
        }
      }
    }
  }
  temp = unlist(word)
  temp = temp[which(names(temp) %in% c("","`e"))]         ##  ̗ŕ͂Ɏĝ͖ƌ`e
  word.t = table(temp)
  word.t = word.t
  voc= data.frame(name = names(word.t),
                  frequancy = as.vector(word.t),
                  density = as.vector(word.t)/sum(word.t)) 
  voc =voc[order(voc$frequancy,decreasing = TRUE),]
  return(list(voc=voc,wlist=temp,doc=word,lda.doc=lda.doc))
}

idat <- Voc(icomment)  ## iphone 7 ̃Rg
gdat <- Voc(gcomment)  ## galaxy s7 ̃Rg

#### 3. wordcloud

library(wordcloud)
library(tm)@
library(RColorBrewer)

#Cẽ[hNEh̕`
## iPhone 7 ̃[hNEh

wordcloud(idat$wlist, scale=c(5,0.7), max.words=100,       ##scale=̔䗦, rot.per =@c̔̕䗦
          random.order=FALSE, rot.per=0.5,
          use.r.layout=TRUE, colors=brewer.pal(8, "Dark2"))

## Galaxy S7 edgẽ[hNEh

wordcloud(gdat$wlist, scale=c(5,0.7), max.words=150,
          random.order=FALSE, rot.per=0.5,
          use.r.layout=FALSE, colors=brewer.pal(8, "Dark2"))

## Ɍ邽߂̏
compare <- c(paste(idat$wlist,collapse = " "),paste(gdat$wlist,collapse = " "))
corpus <- Corpus(VectorSource(compare))
tdm = as.matrix(TermDocumentMatrix(corpus))
colnames(tdm) =c("iPhone 7","Galaxy 7 edge")

## rNEh
comparison.cloud(tdm,random.order=FALSE,title.size=1.5, max.words=100, colors =brewer.pal(8, "Dark2"))
## p_ij 𕶏jɒPim, p_.j,PiŜŌm.
## deviation(max(p_ij - p_.j))̏ԂŊeNXɃvbg
## NX͉ł\


## ގNEh
commonality.cloud(tdm, random.order=FALSE, scale=c(5,0.8),max.words=200,
                  colors = brewer.pal(8, "Dark2"))
##O[vԂŋʂďoPAO[vԂŏopx̍Ԃɕ\܂B
## NX͉ł\

### 4 . LDA
library(lda)
##

l.comment <- lexicalize(idat$lda.doc)
head(l.comment$vocab,10)  #vocabulary
k = 4
set.seed(15)
lda.result <- lda.collapsed.gibbs.sampler(l.comment$documents,
                                          k,
                                          l.comment$vocab,
                                          500,
                                          0.6,
                                          0.1,
                                          compute.log.likelihood = TRUE)


(top.words = top.topic.words(lda.result$topics,6,by.score = TRUE)) 

N <- 1:10
topic.proportions <- t(lda.result$document_sums) / colSums(lda.result$document_sums)
topic.proportions <- topic.proportions[N, ]
topic.proportions[is.na(topic.proportions)] <-  1 / k

# ʂ̃gbv[hpė񖼂āAӖtsB
colnames(topic.proportions) <- apply(top.words, 2, paste, collapse=" ")
par(mfrow=c(1,1))
par(mar=c(5, 14, 2, 2))
barplot(topic.proportions, beside=TRUE, horiz=TRUE, las=1, xlab="proportion")

par(mar=c(5, 10, 5, 5))
barplot(rowSums(lda.result$document_sums/sum(lda.result$document_sums)),xlab="Topic",ylab="Prop",ylim=c(0,0.4),main="Topic Distribution")
axis(1,at=1:4,labels=c("Topic1","Topic2","Topic3","Topic4"))

